/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "settingsdialog.h"

#include "configmiscwidget.h"
#include "configauthorwidget.h"
#include "configstoragewidget.h"
#include "configinterfacewidget.h"

#include <klocale.h>
#include <kglobal.h>
#include <kiconloader.h>

SettingsDialog::SettingsDialog(QWidget *parent, const char *name,KConfigSkeleton *config)
 : KConfigDialog(parent, name, config)
{
  ConfigInterfaceWidget* interface =  new ConfigInterfaceWidget( 0, "Appearance" );
  addPage( interface, i18n("Appearance"), "view_choose" );
      
  ConfigAuthorWidget* author =  new ConfigAuthorWidget( 0, "Author" );
  addPage( author, i18n("Author"), "identity" );
  
  ConfigStorageWidget* storage =  new ConfigStorageWidget( 0, "Storage" );
  addPage( storage, i18n("Storage"), "filesave" );
  
  ConfigMiscWidget* misc =  new ConfigMiscWidget( 0, "Misc" );
  addPage( misc, i18n("Misc"), "misc" );
  
  
  updateGeometry();
}


SettingsDialog::~SettingsDialog()
{
}

