/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "themekreator.h"

#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kurl.h>

#include "themedefinitionloader.h"

static const char description[] =
    I18N_NOOP("A theme creator for SonyEricsson mobile phones.");

static const char version[] = "0.3";

static const KCmdLineOptions options[] =
{
        { "+file", I18N_NOOP("File or URL to open"), 0 },
        KCmdLineLastOption
};

int main(int argc, char **argv)
{
  bool have_top_window = false;
  KAboutData about(
    "themekreator",
    I18N_NOOP("ThemeKreator"),
    version,
    description,
    KAboutData::License_GPL,
    "(C) 2004-2006 Matthias Wetzka",
    0,
    "http://sourceforge.net/projects/themekreator/",
    "matthias.wetzka@gmx.de"
  );
  about.addAuthor( "Matthias Wetzka", 0, "matthias.wetzka@gmx.de" );
  about.setTranslator(I18N_NOOP("NAME OF TRANSLATORS\\004Your names"),I18N_NOOP("EMAIL OF TRANSLATORS\\004Your emails"));
  KCmdLineArgs::init(argc, argv, &about);
  KCmdLineArgs::addCmdLineOptions( options );
  KApplication app;

  
  if (app.isRestored())
  {
    RESTORE(ThemeKreator);
  }
  else
  {
    // no session.. just start up normally
    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

    for(int i = 0; i < args->count(); i++)
    {
      have_top_window = true;
      ThemeKreator *mainWin = new ThemeKreator();
      //app.setMainWidget( mainWin );
      KURL url = args->url(i);
      mainWin->openURL( url, 0 );
      mainWin->show();
    }
    args->clear();
  }


  if(!have_top_window)
  {
    ThemeKreator *mainWin = new ThemeKreator();
    //app.setMainWidget( mainWin );
    //mainWin->selectModel();
    mainWin->show();
  }

   // mainWin has WDestructiveClose flag by default, so it will delete itself.
   return app.exec();
}

