/***************************************************************************
 *   Copyright (C) 2006 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PHONEMODELLOADER_H
#define PHONEMODELLOADER_H

#include <qobject.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qptrlist.h>

class QDomDocument;
class QWidget;

class PhoneModelGroup : public QObject{
public:
    PhoneModelGroup(const QString &name, const QPixmap &icon) : QObject() {
      m_name = name;
      m_icon = icon;
    };
    ~PhoneModelGroup() {};
    QString getName() { return m_name; };
    QPixmap getIcon() { return m_icon; };
private:
    QString m_name;
    QPixmap m_icon;
};


class PhoneModelItem : public QObject{
public:
    PhoneModelItem(const QString &name, const QPixmap &icon, const QString &description) : QObject() {
      m_name = name;
      m_icon = icon;
      m_descr = description;
    };
    ~PhoneModelItem() {};
    QString getName() { return m_name; };
    QPixmap getIcon() { return m_icon; };
    QString getDescription() { return m_descr; };
private:
    QString m_name;
    QPixmap m_icon;
    QString m_descr;
};


/**
	@author Matthias Wetzka <matthias.wetzka@gmx.de>
*/
class PhoneModelLoader{
public:
    PhoneModelLoader(QWidget *parent = 0);
    QPtrList<PhoneModelGroup> *getGroups();
    PhoneModelGroup *getGroup(const QString &version);
    QPtrList<PhoneModelItem> *getModels(const QString &);
    QString findModel(QString);
    ~PhoneModelLoader();
private:
    QDomDocument * m_document;
};


#endif
