/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "previewdatamodel.h"

PreviewDataModel::PreviewDataModel(int width, int height)
 : QObject(), QPtrList<PreviewItem>()
{
  preview_width = width;
  preview_height = height;
}

void PreviewDataModel::append ( PreviewItem * item ) {
  QPtrList<PreviewItem>::append(item);
  connect(item, SIGNAL( signalValueChanged () ), this, SIGNAL( signalValueChanged () ));
}

PreviewDataModel::~PreviewDataModel()
{
  PreviewItem * item;
  for ( item = first(); item; item = next() ) {
    delete item;
  }
}


#include "previewdatamodel.moc"
