/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PREVIEWITEM_H
#define PREVIEWITEM_H

#include <qobject.h>
#include <qrect.h>

class QPainter;

/**
@author Matthias Wetzka
*/
class PreviewItem : public virtual QObject
{
Q_OBJECT
public:
    PreviewItem(int l, int t);

    ~PreviewItem();
    virtual QString getType() { return "none"; };
    
    virtual void draw( QPainter * ) = 0;
    int getWidth() { return width; };
    int getHeight() { return height; };
    int getLeft() { return left; }
    int getTop() { return top; }
    virtual QRect getRect() { return QRect(left, top, width, height); };
    
    virtual QString getToolTip() { return QString::null; };
    
public slots:
    void slotEnterFocus();
    void slotLostFocus();
signals:
    void  signalValueChanged ( );
        
protected:
    int left, top;
    int width, height;
    bool has_focus;
};

#endif
