/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PREVIEWITEMCOLOR_H
#define PREVIEWITEMCOLOR_H

#include "previewitem.h"
#include "themeattributecolor.h"
#include "themeattribute.h"

#include <qbitmap.h>
#include <qpixmap.h>

/**
@author Matthias Wetzka
*/
class PreviewItemColor : public PreviewItem
{
public:
    PreviewItemColor(int left, int top, int width, int height, ThemeAttribute *attribute, int alpha, const QString &bitmapname = 0, ThemeAttribute *depends_on = 0);

    ~PreviewItemColor();
    virtual QString getType() { return "color"; };

    virtual void draw(QPainter* arg1);
    virtual QString getToolTip();

protected:
    QString apply_alpha(QString color, int alpha);
    QBitmap bitmap;
    QPixmap text;
    int alpha;
    ThemeAttributeColor *attribute;
    ThemeAttribute *depends_on;
};

#endif
