/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PREVIEWITEMIMAGE_H
#define PREVIEWITEMIMAGE_H

#include "previewitem.h"
#include "themeattributeimage.h"
#include "themeattribute.h"

#include <qpixmap.h>
#include <qmovie.h>

#include <qobject.h>


/**
@author Matthias Wetzka
*/
class PreviewItemImage : private virtual QObject, public PreviewItem // multiyple inheritnce due to the slot in this class :-(
{
Q_OBJECT
public:
    PreviewItemImage(int left, int top, int width, int height, ThemeAttribute *attribute, int leftoff = 0, int topoff= 0, bool clip = false);

    ~PreviewItemImage();
    virtual QString getType() { return "image"; };

    virtual void draw(QPainter* arg1);
    virtual QString getToolTip();

signals:
    void  signalValueChanged ( );
    void redraw(const QRect&r);
private slots:
    void updatePixmap();
    void movieUpdated(const QRect&);
    
protected:
    int leftoff, topoff;
    //int left_displ, top_displ;
    bool clip;
    QPixmap pixmap;
    QMovie movie;
    bool animated;
    ThemeAttributeImage *attribute;

};

#endif
