/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "previewitempixmap.h"

#include "themeattribute.h"

#include <qpainter.h>

#include <kstandarddirs.h> 

PreviewItemPixmap::PreviewItemPixmap(int left, int top, QString pixmapname, ThemeAttribute *depends_on)
 : PreviewItem(left, top)
{
  pixmap = QPixmap( locate("appdata", pixmapname) );
  width = pixmap.width();
  height = pixmap.height();
  this->depends_on = depends_on;
}


PreviewItemPixmap::~PreviewItemPixmap()
{
}


void PreviewItemPixmap::draw(QPainter* p)
{
  if ( depends_on != 0 && (! depends_on->get_value().isEmpty()) ) {
    //return;
  }
  else {
    if (! pixmap.isNull() ) {
      p->drawPixmap ( left, top, pixmap) ;
    }
  }
}

