/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "themeattributecolor.h"

#include <qlabel.h>
#include <qwidget.h>
#include <kcommand.h>

#include "../ui/mycolorrequester.h"
#include "themeattributeimage.h"

ThemeAttributeColor::ThemeAttributeColor(QString xmlName, QString uiName, QString description, bool required, QString value, KCommandHistory *commandHistory)
 : ThemeAttribute(xmlName, uiName, description, required,value, commandHistory)
{
}


ThemeAttributeColor::~ThemeAttributeColor()
{
}

int ThemeAttributeColor::get_type ( ) {
  return ThemeAttribute::Color;
}

QString ThemeAttributeColor::createXML() {
  if ( value != QString::null ) {
    return "<"+xmlName+" Color=\"0x"+value+"\"/>";
  }
  else {
    return QString::null;;
  }
}

QWidget *ThemeAttributeColor::createLabelWidget(QWidget * parent) {
 if (labelWidget == 0) {
    labelWidget = new QLabel(uiName, parent, "l"+xmlName);
    labelWidget->setAlignment(Qt::AlignLeft | Qt::AlignVCenter | Qt::ExpandTabs);
 }
 return labelWidget;
}

QWidget *ThemeAttributeColor::createEditWidget(QWidget * parent) {
  if (editWidget == 0) {
    editWidget = new MyColorRequester(parent, "colorRequester"+xmlName, this);
    connect(editWidget, SIGNAL(signalEnterFocus()), this, SIGNAL(signalEnterFocus()));
    connect(editWidget, SIGNAL(signalLostFocus()), this, SIGNAL(signalLostFocus()));
  }
  return editWidget;
}

void ThemeAttributeColor::updateSettings() {
  ((MyColorRequester*)editWidget)->updateTooltip();
}

