/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THEMEATTRIBUTECOLOR_H
#define THEMEATTRIBUTECOLOR_H

#include "themeattribute.h"

class ThemeAttributeImage;

/**
@author Matthias Wetzka
*/
class ThemeAttributeColor : public ThemeAttribute
{
public:
    ThemeAttributeColor(QString xmlName, QString uiName, QString description, bool required, QString value, KCommandHistory *commandHistory);

    ~ThemeAttributeColor();
    
    virtual int get_type ( );
    virtual QString createXML();
    virtual QString getXMLTagAttribute() { return "Color"; }
    virtual QWidget *createLabelWidget(QWidget * parent);
    virtual QWidget *createEditWidget(QWidget * parent);
    virtual void updateSettings();
private:
    ThemeAttributeImage* m_depends_on_img;
};

#endif
