/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "themeattributeversion.h"

#include <qlabel.h>
#include <qwidget.h>

#include <kcommand.h>

#include <mylineedit.h>

ThemeAttributeVersion::ThemeAttributeVersion(QString xmlName, QString uiName, QString description, bool required, QString value, KCommandHistory *commandHistory)
 : ThemeAttribute(xmlName, uiName, description, required,value, commandHistory)
{
}


ThemeAttributeVersion::~ThemeAttributeVersion()
{
}

int ThemeAttributeVersion::get_type ( ) {
  return ThemeAttribute::Version;
}

QString ThemeAttributeVersion::createXML() {
  if ( value != QString::null) {
    return "<"+xmlName+" version=\""+value+"\"/>";
  }
  else {
    return QString::null;
  }
}

QWidget *ThemeAttributeVersion::createLabelWidget(QWidget * parent) {
 if (labelWidget == 0) {
    labelWidget = new QLabel(uiName, parent, "l"+xmlName);
    labelWidget->setAlignment(Qt::AlignRight | Qt::AlignVCenter | Qt::ExpandTabs);
 }
 return labelWidget;
}

QWidget *ThemeAttributeVersion::createEditWidget(QWidget * parent) {
  if (editWidget == 0) {
    editWidget = new MyLineEdit(parent, "textLineEdit"+xmlName, this);
  }
  return editWidget;
}


