//
// C++ Interface: themechecker
//
// Description: 
//
//
// Author: Matthias Wetzka <matthias.wetzka@gmx.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef THEMECHECKER_H
#define THEMECHECKER_H

#include <qobject.h>
#include <qptrlist.h>


class ThemeAttribute;
class ThemeFileModel;


/**
	@author Matthias Wetzka <matthias.wetzka@gmx.de>
*/
class ThemeChecker : public QObject
{
Q_OBJECT
public:
    typedef enum { VIOL_COLOR_DISTANCE, VIOL_IMAGE_SIZE, VIOL_UNKNOWN } Violation;
    ThemeChecker(ThemeFileModel *model);
    ~ThemeChecker();
    void setColorDependencies(const QMap<QString, QStringList> &colorDependencyMap);
    
signals:
    void signal_attributeViolation(ThemeChecker::Violation, ThemeAttribute *, ThemeAttribute *);
    
public slots:
    void slot_valueChanged(const QString &);

private:
   ThemeFileModel *model;
   QMap<QString, QStringList> colorDependencyMap;
   QMap<ThemeAttribute *, QPtrList<ThemeAttribute> > violatedColorDependencies;
   void checkColorDependencies(ThemeAttribute *attribute);
   double calculateRGBDistance(const QColor &c1, const QColor &c2);

};

#endif
