/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "uitab.h"

#include "../ui/phonepreview.h"

#include <qwidget.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qlayout.h>

#include <kdialog.h>

UITab::UITab(QString name, PreviewDataModel *model )
 : QPtrList<UIGroup>()
{
  this->name = name;
  this->model = model;
}


UITab::~UITab()
{
  UIGroup * group;
  for ( group = first(); group; group = next() ) {
    delete group;
  }
}

QString UITab::get_name() {
  return name;
}


QWidget *UITab::widget(QWidget * parent) {
  QWidget *tab = new QWidget(parent);
  QHBoxLayout * nsHBox = new QHBoxLayout(tab, 0, 0);
  nsHBox->setAutoAdd(true);
  QWidget * leftPane = new QWidget(tab);
  QVBoxLayout * leftLayout =  new QVBoxLayout(leftPane, KDialog::marginHint(), KDialog::spacingHint());
  
  UIGroup * group;
  for ( group = first(); group; group = next() ) {
    leftLayout->addWidget(group->widget(leftPane));
  }
  leftLayout->addStretch(1);
  
  if (model != 0) {
    QWidget * rightPane = new QWidget(tab);
    QVBoxLayout * rightLayout =  new QVBoxLayout(rightPane, 6, 6);
    rightLayout->addWidget(PhonePreview::previewWidget(rightPane, "preview"+name, model));
    rightLayout->addStretch(1);
  }
  
  return tab;
}
