/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "commandeditattributedirectory.h"

CommandEditAttributeDirectory::CommandEditAttributeDirectory(ThemeAttributeImage * attribute, const QString & newvalue, const QString & newdir, const QString & name)
 : KCommand()
{
  this->attribute = attribute;
  this->oldvalue = attribute->get_value();
  this->olddir = attribute->get_directory();
  this->newvalue = newvalue;
  this->newdir = newdir;
  this->m_name = name;
}

CommandEditAttributeDirectory::~CommandEditAttributeDirectory()
{
}

void CommandEditAttributeDirectory::execute () {
  attribute->set_fullpath(newvalue, newdir, false);
}

void CommandEditAttributeDirectory::unexecute () {
  attribute->set_fullpath(oldvalue, olddir, false);
}

