/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COMMANDEDITATTRIBUTEDIRECTORY_H
#define COMMANDEDITATTRIBUTEDIRECTORY_H

#include <kcommand.h>

#include "model/themeattributeimage.h"

/**
@author Matthias Wetzka
*/
class CommandEditAttributeDirectory : public KCommand
{
public:
    CommandEditAttributeDirectory(ThemeAttributeImage * attribute, const QString & newvalue, const QString & newdir, const QString & name = 0);

    ~CommandEditAttributeDirectory();

    virtual void execute ();
    virtual void unexecute ();
    virtual QString name() const { return m_name; };
    
protected:
    QString olddir;
    QString newdir;
    QString oldvalue;
    QString newvalue;
    QString m_name;
    ThemeAttributeImage * attribute;
};

#endif
