/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COMMANDEDITATTRIBUTEVALUE_H
#define COMMANDEDITATTRIBUTEVALUE_H

#include <kcommand.h>
#include "model/themeattribute.h"

/**
@author Matthias Wetzka
*/
class CommandEditAttributeValue : public KCommand
{
public:
    CommandEditAttributeValue(ThemeAttribute * attribute, const QString & newvalue, const QString & name = 0);

    ~CommandEditAttributeValue();
    
    virtual void execute();
    virtual void unexecute();
    virtual QString name() const { return m_name; };
protected:
    QString oldvalue;
    QString newvalue;
    QString m_name;
    ThemeAttribute * attribute;

};

#endif
