/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MYCOLORREQUESTER_H
#define MYCOLORREQUESTER_H

#include <qwidget.h>

#include <qstring.h>
#include <qcolor.h>

class QGridLayout;
class QHBoxLayout;
class KRestrictedLine;
class KColorButton;
class QLabel;

//class ThemeAttribute;
#include "model/themeattribute.h"

/**
@author Matthias Wetzka
*/
class MyColorRequester : public QWidget
{
Q_OBJECT
public:
    MyColorRequester(QWidget *parent = 0, const char *name = 0, ThemeAttribute * attribute = 0);
    ~MyColorRequester();
    QString text();
    void setAttribute(ThemeAttribute *);
signals:
    void signalEnterFocus();
    void signalLostFocus();
    void focusInEvent ( QFocusEvent * );
    void focusOutEvent ( QFocusEvent * );
public slots:
    void setText( const QString & );
    void updateColorText( const QColor & );
    void updateColorButton( );
    void updateTooltip();

private slots:
    void setInvalid(bool);
    
private:
    QHBoxLayout* myColorRequesterLayout;
    ThemeAttribute * m_attribute;
    //QLabel* lLabel;
    KRestrictedLine* leColor;
    KColorButton* kColorButton;
    QString currentColor; // used to restore old color when user enters only partial content into textedit
    //QString defaultColor;
    //QString invalidColor;
};

#endif
