/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MYKURLREQUESTER_H
#define MYKURLREQUESTER_H

#include <kurlrequester.h>
#include "model/themeattributeimage.h"

class QLabel;
class QSize;
class QGridLayout;
class KTempFile;

/**
@author Matthias Wetzka
*/
class MyKURLRequester : public QHBox
{
Q_OBJECT
Q_PROPERTY( QString url READ url WRITE setURL )
public:
    MyKURLRequester(QWidget *parent = 0, const char *name = 0, QString imagefilter = QString::null, ThemeAttributeImage * attribute = 0);

    ~MyKURLRequester();
    void setAttribute(ThemeAttributeImage *);
    QString url() const;
    void setFilter( const QString& filter );
    KURLCompletion *completionObject() const { return myCompletion; }
    virtual KFileDialog * fileDialog() const;
signals:
    //void urlChanged(const QString &data);
    void textChanged( const QString& );
    void returnPressed();
    void returnPressed( const QString& );
    
public slots:
    void setURL( const QString & );
    void slotToggleEditButton();
    void updateTooltip();
    //void updateColorText( const QColor & );
    //void updateColorButton( );
private slots:
    void setInvalid(bool);
    void slotUpdateURL();
    void slotOpenDialog();
    void slotEdit();
    
private:
    //static KURL * lasturl = 0;
    KLineEdit *edit;
    KURLCompletion *    myCompletion;
    /*KURLDragPushButton*/ KPushButton * btnOpen;
    /*KURLDragPushButton*/ KPushButton * btnEdit;
    mutable KFileDialog * myFileDialog;
    //QGridLayout* myKURLRequesterLayout;
    ThemeAttributeImage * m_attribute;
    QString m_imagefilter;
    //QLabel* lLabel;
    //KURLRequester* urlRequester;
    QString sizeAsText(QSize s);
    KTempFile *resized_image;

};

#endif
