/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "newmodeldialog.h"

#include <qtabwidget.h>
#include <qstrlist.h>
#include <qstringlist.h>
#include <qiconview.h>
#include <qlistbox.h>

#include <kfiledialog.h>
#include <kpushbutton.h>
#include <klocale.h>
#include <kurl.h>

#include "selectmodelwidget.h"


// NewModelDialog::NewModelDialog(QStrList models, QStringList recent, QWidget * parent, const char * name)
NewModelDialog::NewModelDialog(QWidget * parent, const char * name)
 : KDialogBase(parent, 
      "newOpenDialog", 
      true, 
      i18n("New Phone Model"),
      KDialogBase::Ok|KDialogBase::Cancel, 
      KDialogBase::Ok,
      false)
{
  m_sel_model = QString::null;
  init();
  this->enableButtonOK(false); 
}

void NewModelDialog::init() {
/*  tabWidget = new QTabWidget(this);*/
  
  selectModelWidget = new SelectModelWidget(this, "selectModelWidget");

/*  recentThemes = new QListBox(this);
  recentThemes->insertStringList(m_recent);*/
  
/*  openDialog = new KFileDialog(":themedir", i18n("*.thm| Theme Files"), this, "openDialog", false);
  openDialog->setOperationMode( KFileDialog::Opening );*/
  //openDialog->okButton()->hide();
  //openDialog->cancelButton()->hide();
  //connect( (QObject*)selectModelWidget, SIGNAL(selectionChanged (QIconViewItem * )), this, SLOT(selectedModelChanged (QIconViewItem * )));

  
  
/*  tabWidget->addTab(selectModelWidget, i18n("New Theme"));
  tabWidget->addTab(openDialog, i18n("Open Theme"));
  tabWidget->addTab(recentThemes, i18n("Recently Opened"));
  
  setMainWidget(tabWidget);  */
  setMainWidget(selectModelWidget);
  this->adjustSize();
  this->setInitialSize(QSize(600, 440));
}

// void NewModelDialog::selectedModelChanged (QIconViewItem * item) {
//   m_sel_model = item->text();
// }

NewModelDialog::~NewModelDialog()
{
}

QString NewModelDialog::getSelectedModel() {
  return selectModelWidget->getSelectedItemText();
  //return m_sel_model;
}


void NewModelDialog::selectedModelChanged (QIconViewItem * item) {
  if (item) {
    this->enableButtonOK( true );
  }
  else {
    this->enableButtonOK( false );
  }
}

// const KURL &NewModelDialog::getSelectedURL() {
// // openDialog->accept();
//   return openDialog->selectedURL();
// }

// QString NewModelDialog::getSelectedRecent() {
//   return recentThemes->selectedItem()->text();
// }

void NewModelDialog::chosen(QIconViewItem * item)
{
  this->accept();
}

#include "newmodeldialog.moc"
