//
// C++ Implementation: phonepreviewdialog
//
// Description: 
//
//
// Author: Matthias Wetzka <matthias.wetzka@gmx.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "phonepreviewdialog.h"

#include "previewdatamodel.h"
#include "phonepreview.h"
#include "themefilemodel.h"

#include <klocale.h>
#include <kdialogbase.h>

#include <qdict.h>
#include <qlayout.h>

#include <math.h>


PhonePreviewDialog::PhonePreviewDialog(ThemeFileModel *theme_model, QWidget * parent, const char * name )
 : KDialogBase(parent, 
      "newOpenDialog", 
      true, 
      i18n("Previews"),
      KDialogBase::Close, 
      KDialogBase::Close,
      false)
{
  QWidget *pane = new QWidget(this);

  QStringList preview_names = theme_model->getPreviewNames();
  QDict<PreviewDataModel> *previews = theme_model->getPreviews();
  
  int count = previews->count();
  int cols = sqrt(count/0.5);
  QGridLayout *layout = new QGridLayout(pane, count/cols, cols, 10 );
  
  //QDictIterator<PreviewDataModel> it( *previews );
  int i = 0;
  for ( QStringList::Iterator it = preview_names.begin(); it != preview_names.end(); ++it ) {
    layout->addWidget( PhonePreview::previewWidget(pane, "preview"+*it, previews->find(*it)), i/cols, i%cols);
    i++;
  }
  
  this->setMainWidget(pane);
}


PhonePreviewDialog::~PhonePreviewDialog()
{
}


#include "phonepreviewdialog.moc"