/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SELECTMODELDIALOG_H
#define SELECTMODELDIALOG_H

#include <kdialogbase.h>

class QIconViewItem;
class KFileDialog;
class SelectModelIconView;

/**
@author Matthias Wetzka
*/
class SelectModelDialog : public KDialogBase
{
Q_OBJECT
public:
    SelectModelDialog(const QString &version, QWidget * parent = 0, const char * name = 0);

    ~SelectModelDialog();
    
    QString getSelectedModel();
    
public slots:
    void selectedModelChanged (QIconViewItem * item);
    void currentChanged( QIconViewItem * item);
    void chosen(QIconViewItem * item);
        
private:
    QString version;
    QString m_sel_model;
    SelectModelIconView * icon_view;
    void init();

};

#endif
