//
// C++ Implementation: selectmodeliconview
//
// Description: 
//
//
// Author: Matthias Wetzka <matthias.wetzka@gmx.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "selectmodeliconview.h"

#include "phonemodelloader.h"

#include <qstring.h>
#include <qptrlist.h>


SelectModelIconView::SelectModelIconView(PhoneModelLoader *loader, const QString &group, QWidget * parent)
 : QIconView(parent)
{
  this->setBackgroundColor( colorGroup().base() );
  this->setResizeMode(QIconView::Adjust);
  this->setWordWrapIconText( true );
  this->show();
  QPtrList<PhoneModelItem> * models = loader->getModels(group);
  PhoneModelItem * model;
  for ( model = models->first(); model; model = models->next() ) {
    SelectModelIconViewItem * item = new SelectModelIconViewItem(this, model->getName(), model->getIcon(), model->getDescription(), "none");
    //item->setKey(model);
    item->setDragEnabled(false);
    item->setDropEnabled(false);
  }
}


SelectModelIconView::~SelectModelIconView()
{
}



#include "selectmodeliconview.moc"