//
// C++ Interface: selectmodeliconview
//
// Description: 
//
//
// Author: Matthias Wetzka <matthias.wetzka@gmx.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef SELECTMODELICONVIEW_H
#define SELECTMODELICONVIEW_H

#include <qobject.h>
#include <qiconview.h>

class QString;
class PhoneModelLoader;

/**
	@author Matthias Wetzka <matthias.wetzka@gmx.de>
*/
class SelectModelIconView : public QIconView
{
Q_OBJECT
public:
    SelectModelIconView(PhoneModelLoader *loader, const QString &group, QWidget * parent = 0);

    ~SelectModelIconView();

};

class SelectModelIconViewItem : public QIconViewItem
{
    public:
        SelectModelIconViewItem(QIconView *parent=0)
            : QIconViewItem ( parent )
            {}

        SelectModelIconViewItem(QIconView *parent=0, const QString &text=0, const QPixmap &icon=0,
                      const QString &descr=0, const QString &fullname=0)
            : QIconViewItem(parent, text, icon)
            {
            m_descr = descr;
            m_full = fullname;
            }

        QString getDescr() const { return m_descr; }
        QString getFName() const { return m_full; }

    private :
        QString m_descr;
        QString m_full;
};


#endif
