/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SELECTMODELWIDGET_H
#define SELECTMODELWIDGET_H

#include <kiconview.h>
#include <qiconview.h>

#include <qwidget.h>

class KJanusWidget;
class QVGroupBox;
class KTextEdit;

/**
@author Matthias Wetzka
*/
class SelectModelWidget : public QWidget
{
Q_OBJECT
public:
    SelectModelWidget(QWidget *parent = 0, const char *name = 0);

    ~SelectModelWidget();
    
    QString getSelectedItemText();
private:
    KJanusWidget * m_jwidget;
    QVGroupBox * m_descriptiongroup;
    KTextEdit * m_textedit;
    QIconViewItem * m_selected;
    QString descriptionText(const QString &name, const QString &description);
private slots:
    void currentChanged( QIconViewItem * item);
};


#endif
