/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "themeviewwidget.h"

#include <math.h>

#include <qsize.h>
#include <qlistview.h>
#include <qtabwidget.h>
#include <qimage.h> 
#include <qlabel.h> 
#include <qhbox.h>
#include <qlayout.h>

#include <klocale.h>
#include <klistview.h> 
#include <kfileitem.h> 
#include <kfiledialog.h> 
#include <kmessagebox.h>

#include "themekreator.h"
#include "mykurlrequester.h"
#include "mycolorrequester.h"
#include "mylineedit.h"
#include "phonepreview.h"
#include "previewdatamodel.h"
#include "previewitemcolor.h"
#include "previewitemimage.h"
#include "previewitempixmap.h"
#include "uimodel.h"


ThemeViewWidget::ThemeViewWidget(QWidget *parent, const char *name)
   : ThemeView(parent, name)
{
  theme_model = 0;
  uimodel = 0;
  leVersion->setEnabled( false );
  //QString img_filter = "*.png *.jpg *.gif *.jpeg|"+i18n("Supported image types (PNG, JPG, JPEG, GIF)")+"\n*.*|"+i18n("All files");
  //connect(leThemeName, SIGNAL(textChanged( const QString & )), this, SLOT(checkThemeName( const QString & )));
  connect(lvThemeContents, SIGNAL(selectionChanged ()), this, SLOT(updateFileList()) );
  connect( btnExtract, SIGNAL( clicked() ), this, SLOT( extractContent() ));
}

// void ThemeViewWidget::checkThemeName( const QString & newtext ) {
//   if ( newtext.isEmpty() ) {
//     KMessageBox::error(this, i18n("The name of the theme may not be empty.") );
//     leThemeName->undo();
//   }
// }

void ThemeViewWidget::setFileModel(ThemeFileModel * model) {
  if ( model == 0) return;
  theme_model = model;
  
  // remove all tabs except nr 1

/*  connect((QWidget *)cbImagesDesktop, SIGNAL(toggled(bool)), phonePreviewDesktop, SLOT(slotToggleImages(bool )));
  connect((QWidget *)cbImagesDoubleTitle, SIGNAL(toggled(bool)), phonePreviewDoubleTitle, SLOT(slotToggleImages(bool )));
  connect((QWidget *)cbImagesPopup, SIGNAL(toggled(bool)), phonePreviewPopup, SLOT(slotToggleImages(bool )));
  connect((QWidget *)cbImagesSingleTitle, SIGNAL(toggled(bool)), phonePreviewSingleTitle, SLOT(slotToggleImages(bool )));
  connect((QWidget *)cbImagesStandby, SIGNAL(toggled(bool)), phonePreviewStandby, SLOT(slotToggleImages(bool )));
  connect((QWidget *)cbImagesTab, SIGNAL(toggled(bool)), phonePreviewTab, SLOT(slotToggleImages(bool )));
  
  connect((QWidget *)pbSavePreviewDesktop, SIGNAL(clicked()), this, SLOT(savePreviewDesktop()));
  connect((QWidget *)pbSavePreviewDoubleTitle, SIGNAL(clicked()), this, SLOT(savePreviewDoubleTitle()));
  connect((QWidget *)pbSavePreviewPopup, SIGNAL(clicked()), this, SLOT(savePreviewPopup()));
  connect((QWidget *)pbSavePreviewSingleTitle, SIGNAL(clicked()), this, SLOT(savePreviewSingleTitle()));
  connect((QWidget *)pbSavePreviewStandby, SIGNAL(clicked()), this, SLOT(savePreviewStandby()));
  connect((QWidget *)pbSavePreviewTab, SIGNAL(clicked()), this, SLOT(savePreviewTab()));*/
   
}

void ThemeViewWidget::setUIModel(UIModel * ui_model) {
  leVersion->setText( theme_model->getVersion() );
  
  lePhoneModel->setAttribute( theme_model->getAttribute("Phone_model") );
  lPhoneModel->setText( theme_model->getAttribute("Phone_model")->get_uiName() );

  leFirstName->setAttribute( theme_model->getAttribute("Author_firstname") );
  lFirstName->setText( theme_model->getAttribute("Author_firstname")->get_uiName() );
  
  leLastName->setAttribute( theme_model->getAttribute("Author_lastname") );
  lLastName->setText( theme_model->getAttribute("Author_lastname")->get_uiName() );
  
  leOrganization->setAttribute( theme_model->getAttribute("Author_organisation") );
  lOrganization->setText( theme_model->getAttribute("Author_organisation")->get_uiName() );
  
  leEmail->setAttribute( theme_model->getAttribute("Author_email") );
  lEmail->setText( theme_model->getAttribute("Author_email")->get_uiName() );
  
  leURL->setAttribute( theme_model->getAttribute("Author_url") );
  lURL->setText( theme_model->getAttribute("Author_url")->get_uiName() );
  
/*  leThemeName->setAttribute( theme_model->getAttribute("Theme_name") );
  lThemeName->setText( theme_model->getAttribute("Theme_name")->get_uiName() );
  
  leCreationDate->setAttribute( theme_model->getAttribute("Theme_created") );
  lCreationDate->setText( theme_model->getAttribute("Theme_created")->get_uiName() );
  
  leCreator->setAttribute( theme_model->getAttribute("Theme_creator") );
  lCreator->setText( theme_model->getAttribute("Theme_creator")->get_uiName() );
  
  leModifier->setAttribute( theme_model->getAttribute("Theme_modified_by") );
  lModifier->setText( theme_model->getAttribute("Theme_modified_by")->get_uiName() );
*/
//   <Author_firstname
//   <Author_lastname 
//   <Author_organisation
//   <Author_email 
//   <Author_url 


  
  /*while ( tab->count() > 1 ) {
    //TODO tab->removePage( tab->page(1) );
  }*/
  // preview screen
  //tab->addTab(previewWidget(previews), i18n("Previews"));
  // other tabs
  uimodel = ui_model;
  uimodel->widget( tab );
}

void ThemeViewWidget::refreshController() {
/*  if (theme_model != 0) {
    lePhoneModel->setText(theme_model->model);
    leThemeName->setText(theme_model->themeName);
    leCreationDate->setText(theme_model->creationDate);
    leCreator->setText(theme_model->creator);
    leModifier->setText(theme_model->modifier);
  }*/
  
}

void  ThemeViewWidget::updateFileList() {
 /* lvThemeContents->clear();
  QString theme_dir = theme_model->dir;
  for (uint i=0; i < theme_model->file_list.size(); i++) {
    KFileItem * item = new KFileItem(KFileItem::Unknown, KFileItem::Unknown, KURL(theme_dir + theme_model->file_list[i]), true);
    // TODO mybe ist better to use KMimeType::findByFileContent( filename )->name(); ?
    QString type = item->mimeComment();
    QString size = KIO::convertSize(item->size());
    QString dim = "";
    if (item->mimetype().startsWith("image")) {
      QImage *img = new QImage(theme_dir + theme_model->file_list[i]);
      if ( ! img->isNull () ) {
        dim.sprintf("%d x %d ", img->width(), img->height());
      }
    }

    new QListViewItem( lvThemeContents, theme_model->file_list[i], type , size, dim );
  }*/
  toggleExtractBtn();
}

void ThemeViewWidget::toggleExtractBtn() {
  btnExtract->setEnabled( lvThemeContents->selectedItems().count() >= 1 );
}

void ThemeViewWidget::extractContent() {
  QListViewItem *item = lvThemeContents->selectedItem();
  QString attribute = item->text(0);
  ThemeAttributeImage *img = (ThemeAttributeImage *)theme_model->getAttribute( attribute );
//  theme_model->
  KURL url = KFileDialog::getSaveURL(
    img->get_value(),
    img->get_mimetype(),
    this,
    i18n("Choose a filename") );
  if ( url.isValid() ) {
    if ( ! img->copyTo( url, this ) ) {
      KMessageBox::error(this, i18n("An error occured while extracing the image of the themefile.") );
    }
  }
}


void ThemeViewWidget::updatePreview() {
}

void ThemeViewWidget::savePreviewStandby() {
  QString s = KFileDialog::getSaveFileName(":preview", "*.png|"+i18n("PNG Image"), this, i18n("Choose a filename") );
//  if (s.length() > 0)
//    phonePreviewStandby->savePreview(s);
}

void ThemeViewWidget::savePreviewDesktop() {
  QString s = KFileDialog::getSaveFileName(":preview", "*.png|"+i18n("PNG Image"), this, i18n("Choose a filename") );
//  if (s.length() > 0)
//    phonePreviewDesktop->savePreview(s);
}

void ThemeViewWidget::savePreviewDoubleTitle() {
  QString s = KFileDialog::getSaveFileName(":preview", "*.png|"+i18n("PNG Image"), this, i18n("Choose a filename") );
//  if (s.length() > 0)
//    phonePreviewDoubleTitle->savePreview(s);
}

void ThemeViewWidget::savePreviewPopup() {
  QString s = KFileDialog::getSaveFileName(":preview", "*.png|"+i18n("PNG Image"), this, i18n("Choose a filename") );
//  if (s.length() > 0)
//    phonePreviewPopup->savePreview(s);
}

void ThemeViewWidget::savePreviewSingleTitle() {
  QString s = KFileDialog::getSaveFileName(":preview", "*.png|"+i18n("PNG Image"), this, i18n("Choose a filename") );
//  if (s.length() > 0)
//    phonePreviewSingleTitle->savePreview(s);
}

void ThemeViewWidget::savePreviewTab() {
  QString s = KFileDialog::getSaveFileName(":preview", "*.png|"+i18n("PNG Image"), this, i18n("Choose a filename") );
//  if (s.length() > 0)
//    phonePreviewTab->savePreview(s);
}

QString ThemeViewWidget::sizeAsText(QSize s) {
  if (s.isValid())
   return QString( " (%1 x %2)").arg( s.width() ).arg( s.height() );
  else
    return "";
}

ThemeViewWidget::~ThemeViewWidget()
{
  //if ( uimodel != 0) { delete uimodel; }
}

// QWidget * ThemeViewWidget::previewWidget(QDict<PreviewDataModel> *previews) {
//   int count = previews->count();
//   QWidget *pane = new QWidget(this);
//   int cols = sqrt(count/0.5);
//   QGridLayout *layout = new QGridLayout(pane, count/cols, cols, 10 );
//   
//   QDictIterator<PreviewDataModel> it( *previews );
//   int i = 0;
//   for( ; it.current(); ++it ) {
//     layout->addWidget( PhonePreview::previewWidget(pane, "preview"+it.currentKey(), it.current()), i/cols, i%cols);
//     i++;
//   }
//   return pane;
// }

#include "themeviewwidget.moc"

