/***************************************************************************
 *   Copyright (C) 2004 by Matthias Wetzka                                 *
 *   matthias.wetzka@gmx.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef THEMEVIEWWIDGET_H
#define THEMEVIEWWIDGET_H

#include "themeview.h"
#include "model/themefilemodel.h"
#include <qobject.h> 
#include <qlineedit.h> 

class QSize;
class UIModel;
class PreviewDataModel;

class ThemeViewWidget : public ThemeView
{
   Q_OBJECT
   public:
     ThemeViewWidget(QWidget *parent = 0, const char *name = 0);
    ~ThemeViewWidget();
    
    void setFileModel(ThemeFileModel * filemodel);
    void setUIModel(UIModel * uimodel);

   public slots:
     void refreshController();
     void updatePreview();
//     void updateModel() { theme_model->setModel(lePhoneModel->text()); }
     void updateFileList();
     void savePreviewDesktop();
     void savePreviewStandby();
     void savePreviewPopup();
     void savePreviewSingleTitle();
     void savePreviewDoubleTitle();
     void savePreviewTab();

protected:

protected slots:
     void toggleExtractBtn();
     void extractContent();
     
private slots:
     //void checkThemeName( const QString & );
     
private:
    ThemeFileModel * theme_model;
    UIModel * uimodel;
    QString sizeAsText(QSize s);
    //QWidget *previewWidget(QDict<PreviewDataModel> *previews);
};

#endif

